c======================================================================c

      subroutine start_finish( flag )

c======================================================================c

      implicit real*8 (a-h,o-z)
      include 'dirhb.par'
      CHARACTER*5 flag;

      CHARACTER parname*10;
      common /partyp/ parname;

      CHARACTER*2 nucnam;
      common /nucnuc/ amas, nneu, npro, nmas, nucnam;

      common /basnnn/ n0f, n0b;

      common /con_b2/ betac, q0c, cquad, c0, alaq, calcq0, icstr;

      common /fam_flags/ i_coulomb, i_pairing;

      common /fam/ omega_start, omega_end, delta_omega, omega,
     &             gamma_smear, omega_trans_dens,
     &             i_Hartree_response,
     &             J_multipole, K_multipole,
     &             ISO, fac_iso(2);

      common /DDPC1/  a_s, b_s, c_s, d_s,
     &                a_v, b_v, d_v,
     &                b_tv, d_tv,
     &                del_s,
     &                ro_sat;

      common /TMR_param/ G_pairing, a_pairing;



      if( flag .eq. ' end ' ) then

      write(6,*) '';
      write(6,*) '';
      write(6,*) '=============================================',
     &           '===============';
      write(6,*) '=============================================',
     &           '===============';
      write(6,*) '======================               ========',
     &           '===============';
      write(6,*) '======================    END FAM    ========',
     &           '===============';
      write(6,*) '======================               ========',
     &           '===============';
      write(6,*) '=============================================',
     &           '===============';
      write(6,*) '=============================================',
     &           '===============';
      write(6,*) '';
      write(6,*) '';

      return;

      endif



      write(6,'(a)') '                                               ';
      write(6,'(a)') '                                               ';
      write(6,'(a)') '                                               ';
      write(6,'(a)') '  *******************************************  ';
      write(6,'(a)') '  *           Fortran 77 Code               *  ';
      write(6,'(a)') '  *      Relativistic Quasipartice RPA      *  ';
      write(6,'(a)') '  *           Simplex-y Basis               *  ';
      write(6,'(a)') '  *   Finite Amplitude Method Calculation   *  ';
      write(6,'(a)') '  *         with Density-Dependent          *  ';
      write(6,'(a)') '  *          Point Coupling Force           *  ';
      write(6,'(a)') '  *         and Separable Pairing           *  ';
      write(6,'(a)') '  * --------------------------------------- *  ';
      write(6,'(a)') '  *                                         *  ';
      write(6,'(a)') '  * A.Bjelcic, T.Niksic, P.Ring, D.Vretenar *  ';
      write(6,'(a)') '  *                                         *  ';
      write(6,'(a)') '  *******************************************  ';
      write(6,'(a)') '                                               ';


      if( MOD(n0f,2) .ne. 0 ) then
          stop 'Error: n0f has to be even number!';
      endif
      if( parname .ne. 'DD-PC1' ) then
          stop 'Error: FAM implemented only for DD-PC1!';
      endif
      if( MOD(NGH,2) .ne. 0 ) then
          stop 'Error: NGH has to be even number!';
      endif


      infam = 123;
      open( infam , file = 'dirhb.dat' , status = 'old' );
      read (infam,*);read(infam,*);read(infam,*);read(infam,*);
      read (infam,*);read(infam,*);read(infam,*);read(infam,*);
      read (infam,*);read(infam,*);read(infam,*);read(infam,*);
      read (infam,*);read(infam,*);read(infam,*);read(infam,*);
      read (infam,*);
      read (infam,'(20x,i5)') i_coulomb;
      read (infam,'(20x,i5)') i_pairing;
      read (infam,*);
      read (infam,*);
      read (infam,*);
      read (infam,'(20x,i5)') J_multipole;
      read (infam,'(20x,i5)') K_multipole;
      read (infam,'(20x,i5)') ISO;
      read (infam,*);
      read (infam,'(20x,1f8.3)') omega_start;
      read (infam,'(20x,1f8.3)') omega_end;
      read (infam,'(20x,1f8.3)') delta_omega;
      read (infam,'(20x,1f8.3)') gamma_smear;
      read (infam,*);
      read (infam,'(20x,i5)') i_Hartree_response;
      read (infam,*);
      read (infam,'(20x,1f8.3)') omega_trans_dens;
      close(infam);







c-----DD-PC1 parameters
      a_s    = - 10.0462D0; ![fm^2]
      b_s    = -  9.1504D0; ![fm^2]
      c_s    = -  6.4273D0; ![fm^2]
      d_s    = +  1.3724D0; ![    ]

      a_v    = +  5.9195D0; ![fm^2]
      b_v    = +  8.8637D0; ![fm^2]
      d_v    = +  0.6584D0; ![    ]

      b_tv   = +  1.8360D0; ![fm^2]
      d_tv   = +  0.6403D0; ![    ]

      del_s  = -  0.8149D0; ![fm^4]

      ro_sat = +   0.152D0; ![fm^-3]

c-----TMR separable pairing parameters
      G_pairing = 728.D0;        ![MeV/fm^3]
      a_pairing = 0.644204936D0; ![fm]






      fac_iso(1) = + 1.D0;
      fac_iso(2) = + 1.D0;

      if( ISO .eq. 1 ) then
          if( J_multipole .eq. 1 ) then
              fac_iso(1) = - DBLE(npro) / DBLE(npro+nneu);
              fac_iso(2) = + DBLE(nneu) / DBLE(npro+nneu);
          else
              fac_iso(1) = - 1.D0;
              fac_iso(2) = + 1.D0;
          endif
      endif





      return;
      end;
