c======================================================================c

      REAL*8 function strength( lpr , it )

c======================================================================c

      implicit real*8 (a-h,o-z)
      include 'dirhb.par'
      logical lpr;



      common /mathco/ zero, one, two, half, third, pi;

      common /fam/ omega_start, omega_end, delta_omega, omega,
     &             gamma_smear, omega_trans_dens,
     &             i_Hartree_response,
     &             J_multipole, K_multipole,
     &             ISO, fac_iso(2);

      CHARACTER fg_spx;
      common /simplex/ N_total         , N_blocks        ,
     &                 ia_spx(NBX)     , id_spx(NBX)     ,
     &                 nf_size(NBX)    , ng_size(NBX)    ,
     &                 nz_spx(NBSX,NBX), nr_spx(NBSX,NBX),
     &                 ml_spx(NBSX,NBX), fg_spx(NBSX,NBX);

      COMPLEX*16 f1_JK, f2_JK;
      common /f_matrix/ f1_JK( NTX , NTX , 2 ),
     &                  f2_JK( NTX , NTX , 2 );

      COMPLEX*16 drho_1, drho_2;
      common /delta_rho/ drho_1( NTX , NTX , 2 ),
     &                   drho_2( NTX , NTX , 2 );


      COMPLEX*16 trace;


      if(lpr) then
      write(6,*) '';
      write(6,*) '****** BEGIN strength() ****************************';
      write(6,*) '';
      endif


      trace = COMPLEX( 0.D0 , 0.D0 );

      do i = 1 , N_total
          do j = 1 , N_total
              trace = trace + DCONJG(f1_JK(i,j,it))*drho_1(i,j,it)
     &                      + DCONJG(f2_JK(i,j,it))*drho_2(i,j,it);
          enddo
      enddo


      strength = - 1.D0/pi * DIMAG( trace );


      if(lpr) then
      write(6,*) '';
      write(6,*) '****** END strength() ******************************';
      write(6,*) '';
      endif

      return;
      end;
